<template>
  <LayoutMain>
    <section>
      <!-- SECCION TITULO -->
      <b-container>
        <b-row align-h="center">
          <b-col v-if="state == null" cols="12">
            <TitleShape title="Que comience el juego!" />
          </b-col>
          <b-col v-if="state == 'playing'" cols="12">
            <TitleShape :title=  category.title />
          </b-col>
          <b-col v-if="state == 'resolved'" cols="12">
            <TitleShape :title=  category.title />
          </b-col>
          <b-col v-if="state == 'ended'" cols="12">
            <TitleShape title= "Fin de la partida" />
          </b-col>
        </b-row>
      </b-container>
      <!-- SECCION JUEGO -->
      <div class="color-wrapper">
        <b-overlay :show="isLoading" rounded="sm">
          <b-container>
            <!-- FILA DE PUNTUACIÓN, RONDA, FALLOS Y TIEMPO DE RONDA -->
            <b-row v-if="state != null">
              <b-col cols="3">
                <InfoBorder clave="PTS:" :info="score"/>
              </b-col>
              <b-col cols="3" class="text-center">
                <InfoBorder clave="Round:" :info="round"/>
              </b-col>
              <b-col cols="3" class="text-center">
                <InfoBorder clave="Misses:" :info="misses"/>
              </b-col>
              <b-col cols="3" class="text-right">
                <InfoBorder clave="Seg:" :info="remaining_time"/>
              </b-col>
            </b-row>
            <!-- FILA DE TABLERO Y CARTAS -->
            <b-row>
              <!-- columna con botón "jugar" si no ha empezado la partida -->
              <b-col v-if="state == null" align-v="center" cols="12" class="text-center">
                <b-button size="lg" v-on:click="start()">Jugar</b-button>
              </b-col>
              <!-- columna con el tablero de juego -->
              <b-col v-else align-v="center" cols="12" class="text-center">
                <b-row>
                  <b-col cols="12">
                    
                      <!-- tablero -->
                      <draggable
                        class="row drop"
                        :list="answer"
                        group="cards"
                        @change="log"
                        :sort="false"
                        ghost-class="ghost"
                        :disabled="['resolved', 'ended'].includes(state)"
                      >
                        <!-- carta -->
                        <b-col cols="2"  v-for="(card, index) in answer" :key="card.id">
                          <Card :title="card.title" :year="card.year"/>
                        </b-col>
                      </draggable>
                    
                  </b-col>
                  <b-col cols="12">
                      <template v-if="state == 'playing'">
                        <draggable
                          class="row drop"                          
                          :list="hand_cards"
                          group="cards"
                          @change="log"
                          :sort="false"
                          ghost-class="ghost"
                          :disabled="state == 'resolved'"
                        >
                          <b-col
                            cols="2"
                            v-for="(card, index) in hand_cards"
                            :key="card.id"
                          >
                          <Card :title="card.title" :year="card.year"/>                          
                          </b-col>
                        </draggable>
                        <b-row align-h="center">
                          <b-col align-v="center" cols="12" class="text-center">
                            <b-button size="lg" v-on:click="resolve()">Resolver</b-button>
                          </b-col>
                        </b-row>
                      </template>
                      <template v-else-if="state == 'resolved'">
                        <b-row align-h="center">
                          <b-col align-v="center" cols="12" class="text-center">
                            <b-button size="lg" v-on:click="hand()">Siguiente ronda</b-button>
                          </b-col>
                        </b-row>
                      </template>
                      <template v-else-if="state == 'ended'">
                        <b-row align-h="center">
                        <b-col align-v="center" cols="12" class="text-center">
                          <b-button size="lg" v-on:click="start()">Volver a jugar</b-button>
                        </b-col>
                        </b-row>
                      </template>
                  </b-col>
                </b-row>
              </b-col>
            </b-row>
          </b-container>
        </b-overlay>
      </div>
    </section>
  </LayoutMain>
</template>

<script>
import draggable from "vuedraggable";
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import Card from "@/components/Card.vue";
import InfoBorder from "@/components/InfoBorder.vue";
import { mapGetters } from "vuex";

// @ is an alias to /src
export default {
  components: {
    LayoutMain,
    TitleShape,
    draggable,
    Card,
    InfoBorder
  },
  name: "gameStart",
  props: ["category_id"],
  data() {
    return {
      category: {},
      hand_cards: [],
      answer: [],
      game_id: null,
      score: 0,
      misses: 0,
      remaining_time: 0,
      round: 0,
      remaining_time_to: null,
      state: null,
    };
  },

  mounted() {
    this.$store
      .dispatch("category/show", { id: this.category_id })
      .then((resp) => {
        this.category = resp.data;
      });
  },
  computed: {
    ...mapGetters("game", ["isLoading"]),
  },
  methods: {
    log: function (evt) {
      window.console.log(evt);
    },
    start: function () {
      this.$store
        .dispatch("game/start", { category_id: this.category.id })
        .then((resp) => {
          this.game_id = resp.data.id;
          this.score = resp.data.score;
          this.misses = resp.data.misses;
          this.round = resp.data.round;
          this.hand();
        });
    },
    end: function () {
      this.$store.dispatch("game/end").then((resp) => {});
    },
    resolve: function () {
      this.state = "resolved";
      clearTimeout(this.remaining_time_to);
      let formData = new FormData();
      //Agrego mediante "append" los valores del formulario al nuevo formData
      let answer = this.answer.map((element) => element.id);
      let params = {
        round: this.round,
        answer: answer,
      };

      // // Resolver mano de cartas
      this.$store
        .dispatch("game/resolve", { id: this.game_id, params })
        .then((resp) => {
          let resolved = this.answer.concat(this.hand_cards)
          resolved.map((element)=> {element.year = resp.data.correct_answer[element.id]})

          resolved.sort((a,b)=> a.year-b.year)
          
          this.hand_cards = []
          
          this.answer = resolved

          this.score = resp.meta.score;
          this.misses = resp.meta.misses;
          if (resp.meta.end) {
            this.state = "ended";
          }
        });
    },
    hand: function () {
      this.state = "playing";
      this.$store.dispatch("game/hand", { id: this.game_id }).then((resp) => {
        this.answer = []
        this.hand_cards = resp.data;
        this.round = resp.meta.round;
        this.remaining_time = resp.meta.round_time;
        this.countDownTimer();
      });
    },
    countDownTimer() {
      if (this.remaining_time > 0) {
        this.remaining_time_to = setTimeout(() => {
          this.remaining_time -= 1;
          this.countDownTimer();
        }, 1000);
      } else {
        this.resolve();
      }
    },
  },
};
</script>

<style scoped>
.drop {
  width: 100%;
  min-height: 200px;
  justify-content: center;
  vertical-align: top;
  padding: 15px;
  margin-bottom: 20px;
  height: auto;
  border: 2px solid gray;
}

.ghost {
  opacity: 0.5;
  background: #c8ebfb;
}
</style>